﻿Function Main{
Set-StrictMode -Version "2.0"
Clear-Host

Push-Location $(Split-Path $Script:MyInvocation.MyCommand.Path)

#definitions
$remote = "http://xmltv.xmltv.se/"

$temp = "..\epg\temp\"
$inFile = "..\epg\temp\full.xml"
$outFile = "..\epg\full.xml.gz"
$extra = "..\epg\1.a.channels-extra.xml"
$exe = "..\epg\mc2xml.exe"

if ((Test-Path $outFile) -and ($a = (gci $outfile | Where{$_.LastWriteTime -ge (Get-Date).AddDays(-13)})))
{
write-host "Kein Update erforderlich"
Start-Sleep -s 3
}

else{
ni $outFile -type file -ErrorAction SilentlyContinue
write-host "Update erforderlich"
createpaths
get -number 14
merging
gzip
cleanup
}
}

#===============================================================
# Funktionen
#===============================================================
function createpaths {

ni -ItemType Directory -Force -Path "$temp"
ri "$temp\*.xml"
ri "*.xml.gz"
cpi -Path "$extra" -Destination "$temp"
}

function get{ 
param($number=2)

&$exe -U -D "mc2xml.dat" -L -o "xmltv.xml"
cpi -Path "xmltv.xml" -Destination "$temp"

#getting extra channels
echo "Getting extra channels.";

[xml] $xdoc = New-Object XML
$xdoc.Load("$extra")
$Value = ($xdoc.GetElementsByTagName("id"))

   for ($i=0;$i -le $number;$i++){
        $today = "_" + (Get-Date -f yyyy-MM-dd ((Get-Date).adddays($i))) 
        foreach($Value in $xdoc.SelectNodes("//channel") | % { $_.id }) {
            wget "$remote$Value$today.xml.gz" -OutFile "$temp$Value$today.xml"
            }
        }
}

function merging{
echo "Merging the lists.";

$xmldoc = new-object xml
$rootnode = $xmldoc.createelement("tv")
$xmldoc.appendchild($rootnode)
$xmldoc.InsertBefore($xmldoc.CreateXmlDeclaration("1.0", "utf-8", $null), $rootnode)
$finalXml = ""
 foreach ($file in (gci "$temp")) {
    $xmltoadd = select-xml -path $file.FullName -xpath "/*"
    $xml2 = $xmltoadd.node.innerxml | select –Unique
    $finalxml += $xml2
}
$rootnode.innerxml = $finalxml
$xmldoc.Save("$inFile")
}

function gzip{
echo "Compressing $inFile to $outFile";

$input = New-Object System.IO.FileStream $inFile, ([IO.FileMode]::Open), ([IO.FileAccess]::Read), ([IO.FileShare]::Read);
$output = New-Object System.IO.FileStream $outFile, ([IO.FileMode]::Create), ([IO.FileAccess]::Write), ([IO.FileShare]::None)
$gzipStream = New-Object System.IO.Compression.GzipStream $output, ([IO.Compression.CompressionMode]::Compress)

try {
$buffer = New-Object byte[](1024);
while($true) {
$read = $input.Read($buffer, 0, 1024)
if ($read -le 0) {
break;
}
$gzipStream.Write($buffer, 0, $read)
}
}
finally {
$gzipStream.Close();
$output.Close();
$input.Close();
}
}

function cleanup{
echo "Cleaning up.";

ri "$temp\*.xml"
rv final*
rv xml*
rv root*
[System.GC]::Collect()

echo “Done.”;
}
Main